#!/usr/bin/env perl

use strict;
use warnings;

my $nc_name = "named.conf.txt";    # Путь к конфигу днс сервера
my $zl_name = "test.txt";          # файл, который я буду забирать
my $write_conf = 0;
my @zones = ();

# Получаем список доменов
# парсим строки вида zone "zone.name"
# пофигу сколько пробелов между директивой и именем зоны
# главное, чтобы директива и имя зоны были в одной строке
open(FIN, '<', $nc_name) || die "error: $!\n";
while (<FIN>){
	chomp; $_ = lc;
	if (/zone[ ]+"(([a-z1-9\-]+?\.)+?[a-z1-9\-]+)"/){
		push(@zones, $1);
	}
}
close(FIN);

# Проверяем были ли добавлены/удалены зоны
if (open(FIN, '<', $zl_name)){
	my @old_zones = ();

	while (<FIN>){
		chomp; $_ = lc;
		next unless /([a-z1-9\-]+?\.)+?[a-z1-9\-]+/;
		push(@old_zones, $_);
	}

	if ($#zones != $#old_zones){ $write_conf = 1; }
	else {
		foreach (@zones){
			if (!($_ ~~ @old_zones)){
				$write_conf = 1;
				last;
			}
		}
	}

	close(FIN);
} else {
	$write_conf = 1;
}

# Пишем в файл (кот. забираться другим скриптом) найденные зоны
if ($write_conf){
	@zones = sort(@zones);
	open(FOUT, '>', $zl_name) || die "error: $!\n";
	foreach (@zones){ print(FOUT "$_\n"); }
	close(FOUT);
}

exit(0);
